Programmatic support for redaction in JavaScript (ES5) PdfViewer

3 Aug 20267 minutes to read

The Syncfusion JavaScript PdfViewer control provides APIs to add, update, delete, and apply redaction annotations programmatically. You can also redact entire pages, configure default properties, and work with the redaction property panel.

Enable the redaction toolbar

To enable the redaction toolbar, configure the toolbarSettings.toolbarItems property of the PdfViewer instance to include the RedactionEditTool.

The following example shows how to enable the redaction toolbar:

var pdfviewer = new ej.pdfviewer.PdfViewer({
  documentPath: 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
  resourceUrl: "https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib",
  toolbarSettings: {
    toolbarItems: [
      'OpenOption',
      'UndoRedoTool',
      'PageNavigationTool',
      'MagnificationTool',
      'PanTool',
      'SelectionTool',
      'CommentTool',
      'SubmitForm',
      'AnnotationEditTool',
      'RedactionEditTool',   // Enables Redaction toolbar
      'FormDesignerEditTool',
      'SearchOption',
      'PrintOption',
      'DownloadOption'
    ]
  }
});
ej.pdfviewer.PdfViewer.Inject(ej.pdfviewer.TextSelection, ej.pdfviewer.TextSearch, ej.pdfviewer.Print, ej.pdfviewer.Navigation, ej.pdfviewer.Toolbar, ej.pdfviewer.Magnification, ej.pdfviewer.Annotation, ej.pdfviewer.FormDesigner, ej.pdfviewer.FormFields, ej.pdfviewer.PageOrganizer);
pdfviewer.appendTo('#PdfViewer');

Add redaction annotations programmatically

You can add redaction annotations to a PDF document using the addAnnotation method of the annotation module.

    <button id="addRedactAnnot">Add Redaction Annotation</button>
document.getElementById('addRedactAnnot').addEventListener('click', () => {
    viewer.annotation.addAnnotation("Redaction", {
        bound: { x: 200, y: 480, width: 150, height: 75 },
        pageNumber: 1,
        markerFillColor: '#0000FF',
        markerBorderColor: 'white',
        fillColor: 'red',
        overlayText: 'Confidential',
        fontColor: 'yellow',
        fontFamily: 'Times New Roman',
        fontSize: 8,
        beforeRedactionsApplied: false
    });
});

You can listen to the annotationAdd event to track when annotations are added:

viewer.annotationAdd = (args) => {
    console.log('Annotation added:', args);
};

Delete redaction annotations programmatically

Redaction annotations can be removed using the deleteAnnotationById method or by selecting and deleting them through code.

    <button id="deleteAnnotationbyId">Delete Annotation By Id</button>
// Delete annotation by id
document.getElementById('deleteAnnotationbyId').addEventListener('click', () => {
    viewer.annotationModule.deleteAnnotationById(
      viewer.annotationCollection[0].annotationId
    );
  });

Alternatively, you can remove annotations by selecting them in the UI and pressing the Delete key.

Update redaction annotation properties programmatically

You can update properties of an existing redaction annotation using the editAnnotation API. For example, to change overlay text or fill color:

<button id="editRedactAnnotation">Edit Redact Annotation</button>
let editRedactAnnotation = document.getElementById('editRedactAnnotation');
if (editRedactAnnotation) {
editRedactAnnotation.addEventListener('click', function () {
    if (viewer) {
        for (let i = 0; i < viewer.annotationCollection.length; i++) {
            if (viewer.annotationCollection[i].subject === "Redaction") {
                viewer.annotationCollection[i].overlayText= 'EditedAnnotation',
                viewer.annotationCollection[i].markerFillColor= '#22FF00',
                viewer.annotationCollection[i].markerBorderColor= '#000000',
                viewer.annotationCollection[i].isRepeat= true,
                viewer.annotationCollection[i].fillColor= '#F8F8F8',
                viewer.annotationCollection[i].fontColor= '#333333',
                viewer.annotationCollection[i].fontSize= 14,
                viewer.annotationCollection[i].fontFamily= 'Symbol',
                viewer.annotationCollection[i].textAlign= 'Right'
                viewer.annotationCollection[i].beforeRedactionsApplied= false
                viewer.annotation.editAnnotation(viewer.annotationCollection[i]);
            }
        }
    }
});
}

Add page redactions programmatically

Entire pages can be marked for redaction using the addPageRedactions method:

    <button id="addPageRedactions">Add Page Redaction</button>
document.getElementById('addPageRedactions').addEventListener('click', () => {
    viewer.annotation.addPageRedactions([1, 3, 5, 7]); // Redacts pages 1, 3, 5, and 7
});

Apply redaction programmatically

Once annotations are added, you can permanently apply them to the document using the redact method:

    <button id="redact">Apply Redaction</button>
document.getElementById('redact').addEventListener('click', () => {
    viewer.annotation.redact();
});

NOTE

Applying redaction is irreversible. Before calling redact(), save or export a backup copy of the document; the original content cannot be recovered.

Configure default redaction annotation properties

You can configure default properties for redaction annotations (such as fill color, overlay text, and font) when adding them programmatically:

viewer.redactionSettings= {
        overlayText: 'Confidential',
        markerFillColor: '#FF0000',
        markerBorderColor: '#000000',
        isRepeat: false,
        fillColor: '#F8F8F8',
        fontColor: '#333333',
        fontSize: 14,
        fontFamily: 'Symbol',
        textAlign: 'Right'
    };

View Sample in GitHub

Redaction property panel

The redaction property panel allows users to update annotation properties through the UI. Programmatically, you can invoke the property panel by selecting an annotation and calling the relevant APIs. Properties such as overlay text, font style, and fill color can be updated directly in the panel.

Redaction property panel showing overlay text and color options

See also

Programmatic support for redaction in React PDF Viewer

23 Jul 202610 minutes to read

Overview

This guide shows how to add, edit, delete, mark full pages, and apply redaction annotations programmatically in the React PDF Viewer.

Outcome: You will have working code to control redactions from UI buttons and to set default redaction properties.

Prerequisites

  • EJ2 React PDF Viewer installed and configured in your project. See getting started guide.
  • A resourceUrl or service endpoint if using remote viewer assets (examples below use Syncfusion CDN). Ensure browser access to the CDN.

Steps

  1. Enable the Redaction toolbar entry so the UI exposes redaction controls.
  2. Add redaction annotations programmatically with addAnnotation('Redaction', ...).
  3. Delete annotations by id via deleteAnnotationById(id) or by selecting and deleting in the UI.
  4. Update existing redaction properties with editAnnotation(annotationObject).
  5. Mark entire pages using addPageRedactions([pageNumbers]).
  6. Permanently apply redactions with redact() (irreversible — back up originals).
  7. Configure redactionSettings on the viewer for defaults used when creating redactions.

Quick example (individual operations)

viewerRef.current.annotation.addAnnotation('Redaction', {
  bound: { x: 200, y: 480, width: 150, height: 75 },
  pageNumber: 1,
  overlayText: 'Confidential',
  fillColor: '#000000'
} as RedactionSettings);
  • Delete a redaction by id:
const id = viewerRef.current.annotationCollection?.[0]?.annotationId;
viewerRef.current.annotationModule.deleteAnnotationById(id);
  • Edit a redaction (modify object then call edit):
const annot: any = viewerRef.current.annotationCollection.find(a => a.subject === 'Redaction');
annot.overlayText = 'Edited';
viewerRef.current.annotation.editAnnotation(annot);
  • Mark full pages:
viewerRef.current.annotation.addPageRedactions([1,3]);
  • Apply redactions (permanent):
viewerRef.current.annotation.redact();

Complete example

The following example shows a PdfViewer and buttons for Add / Delete / Edit / Page Redact / Apply Redaction and sets default redaction properties.

import { useRef, useEffect, RefObject } from 'react';
import {
    PdfViewerComponent, Toolbar, Magnification, Navigation, Annotation, LinkAnnotation,
    BookmarkView, ThumbnailView, Print, TextSelection, TextSearch, FormFields,
    FormDesigner, Inject, ToolbarItem, RedactionSettings, ToolbarSettingsModel
} from '@syncfusion/ej2-react-pdfviewer';

export default function App() {
    const viewerRef: RefObject<PdfViewerComponent> = useRef(null);
    const documentPath: string = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';
    const resourceUrl: string = 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib';

    const toolbarSettings: ToolbarSettingsModel = {
        toolbarItems: [
            'OpenOption', 'UndoRedoTool', 'PageNavigationTool', 'MagnificationTool', 'PanTool',
            'SelectionTool', 'CommentTool', 'AnnotationEditTool', 'RedactionEditTool', 'SearchOption',
            'PrintOption', 'DownloadOption'
        ] as ToolbarItem[]
    };

    useEffect(() => {
        if (!viewerRef.current) return;
        // Set default redaction properties
        viewerRef.current.redactionSettings = {
            overlayText: 'Confidential',
            markerFillColor: '#FF0000',
            markerBorderColor: '#000000',
            isRepeat: false,
            fillColor: '#000000',
            fontColor: '#FFFFFF',
            fontSize: 12,
            fontFamily: 'Helvetica',
            textAlignment: 'Center'
        };
    }, []);

    const addRedaction = (): void => {
        const viewer = viewerRef.current as PdfViewerComponent;
        if (!viewer) return;
        viewer.annotation.addAnnotation('Redaction', {
            bound: { x: 150, y: 400, width: 200, height: 40 },
            pageNumber: 1,
            overlayText: 'Confidential',
            fillColor: '#000000',
            fontColor: '#FFFFFF'
        } as RedactionSettings);
    };

    const deleteFirstAnnotation = (): void => {
        const viewer = viewerRef.current;
        const id = viewer?.annotationCollection?.[0]?.annotationId;
        if (id) viewer.annotationModule.deleteAnnotationById(id);
    };

    const editRedaction = (): void => {
        const viewer = viewerRef.current;
        const collection = viewer?.annotationCollection || [];
        const annot = collection.find(a => a.subject === 'Redaction');
        if (annot) {
            annot.overlayText = 'Edited';
            annot.fillColor = '#333333';
            annot.fontSize = 14;
            viewer.annotation.editAnnotation(annot);
        }
    };

    const addPageRedactions = (): void => {
        viewerRef.current.annotation.addPageRedactions([1]);
    };

    const applyRedactions = (): void => {
        // WARNING: irreversible
        viewerRef.current.annotation.redact();
    };

    return (
        <div>
            <div style={{ display: 'flex', gap: 8, marginBottom: 12 }}>
                <button onClick={addRedaction}>Add Redaction</button>
                <button onClick={deleteFirstAnnotation}>Delete First Annotation</button>
                <button onClick={editRedaction}>Edit Redaction</button>
                <button onClick={addPageRedactions}>Mark Page Redaction</button>
                <button onClick={applyRedactions}>Apply Redactions (Permanent)</button>
            </div>

            <PdfViewerComponent
                id="container"
                ref={viewerRef}
                documentPath={documentPath}
                resourceUrl={resourceUrl}
                toolbarSettings={toolbarSettings}
                style={{ height: '640px' }}>
                <Inject services={[Toolbar, Magnification, Navigation, Annotation, LinkAnnotation, BookmarkView, ThumbnailView, Print, TextSelection, TextSearch, FormFields, FormDesigner]} />
            </PdfViewerComponent>
        </div>
    );
}

Expected result: The viewer loads the sample PDF. Clicking the buttons will add, delete, edit, mark pages for redaction, or permanently apply redactions.

Troubleshooting

  • No viewer assets / missing icons: confirm resourceUrl is reachable from the browser and points to a compatible ej2-pdfviewer-lib version.
  • viewerRef.current is undefined: ensure the PdfViewerComponent renders before calling APIs (wrap API calls in event handlers or use useEffect after mount).
  • Applying redactions fails: ensure the viewer has finished loading the document and that any server-side redaction workflows (if used) are available. Always backup originals before applying.

Programmatic support for redaction in Angular PdfViewer

11 Feb 202622 minutes to read

The Syncfusion Angular PdfViewer control provides APIs to add, update, delete, and apply redaction annotations programmatically. You can also redact entire pages, configure default properties, and work with the redaction property panel.

Enable the redaction toolbar

To enable the redaction toolbar, configure the toolbarSettings.toolbarItems property of the PdfViewer instance to include the RedactionEditTool.

The following example shows how to enable the redaction toolbar:

import { Component, ViewChild } from '@angular/core';
import {
  PdfViewerComponent,
  LinkAnnotationService,
  BookmarkViewService,
  MagnificationService,
  ThumbnailViewService,
  ToolbarService,
  NavigationService,
  AnnotationService,
  TextSearchService,
  TextSelectionService,
  PrintService,
  FormFieldsService,
  FormDesignerService,
  PageOrganizerService,
  ToolbarSettingsModel
} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  template: `
    <div class="content-wrapper">
      <ejs-pdfviewer
        #pdfviewer
        id="pdfViewer"
        [resourceUrl]="resourceUrl"
        [documentPath]="documentPath"
        [toolbarSettings]="toolbarSettings"
        style="height:640px;display:block">
      </ejs-pdfviewer>
    </div>
  `,
  providers: [
    LinkAnnotationService,
    BookmarkViewService,
    MagnificationService,
    ThumbnailViewService,
    ToolbarService,
    NavigationService,
    AnnotationService,
    TextSearchService,
    TextSelectionService,
    PrintService,
    FormFieldsService,
    FormDesignerService,
    PageOrganizerService
  ]
})
export class AppComponent {
  @ViewChild('pdfviewer', { static: true }) pdfViewer!: PdfViewerComponent;

  // Standalone mode (CDN) – keep this version aligned with your package
  public resourceUrl = 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib';
  public documentPath = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';

  // Matches your JS toolbar configuration, with RedactionEditTool included
  public toolbarSettings: ToolbarSettingsModel = {
    toolbarItems: [
      'OpenOption',
      'UndoRedoTool',
      'PageNavigationTool',
      'MagnificationTool',
      'PanTool',
      'SelectionTool',
      'CommentTool',
      'SubmitForm',
      'AnnotationEditTool',
      'RedactionEditTool',   // Redaction entry in the primary toolbar
      'FormDesignerEditTool',
      'SearchOption',
      'PrintOption',
      'DownloadOption'
    ]
  };
}

Add redaction annotations programmatically

You can add redaction annotations to a PDF document using the addAnnotation method of the annotation module. You can listen to the annotationAdd event to track when annotations are added.

import { Component, ViewChild } from '@angular/core';
import {
  PdfViewerComponent,
  LinkAnnotationService,
  BookmarkViewService,
  MagnificationService,
  ThumbnailViewService,
  ToolbarService,
  NavigationService,
  AnnotationService,
  TextSearchService,
  TextSelectionService,
  PrintService,
  FormFieldsService,
  FormDesignerService,
  PageOrganizerService,
  ToolbarSettingsModel
} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  // Inline template—kept minimal and close to your JS structure
  template: `
    <div class="content-wrapper">
      <div style="margin-bottom:8px;display:flex;gap:8px;align-items:center;">
        <button id="addRedactAnnot" type="button" (click)="addRedaction()">
          Add Redaction Annotation
        </button>
      </div>
      <ejs-pdfviewer
        #pdfviewer
        id="PdfViewer"
        [documentPath]="document"
        [resourceUrl]="resource"
        [toolbarSettings]="toolbarSettings"
        style="height:640px;display:block"
        (annotationAdd)="onAnnotationAdd($event)">
      </ejs-pdfviewer>
    </div>
  `,
  providers: [
    LinkAnnotationService,
    BookmarkViewService,
    MagnificationService,
    ThumbnailViewService,
    ToolbarService,
    NavigationService,
    AnnotationService,
    TextSearchService,
    TextSelectionService,
    PrintService,
    FormFieldsService,
    FormDesignerService,
    PageOrganizerService
  ]
})
export class AppComponent {
  @ViewChild('pdfviewer', { static: true }) pdfViewer!: PdfViewerComponent;

  // Update these as needed
  public document = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';
  public resource = 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib';

  // Keep toolbar simple; include redaction edit tool if you want UI access too
  public toolbarSettings: ToolbarSettingsModel = {
    toolbarItems: [
      'OpenOption',
      'PageNavigationTool',
      'MagnificationTool',
      'PanTool',
      'SelectionTool',
      'AnnotationEditTool',
      'RedactionEditTool',   // shows the redaction UI tool (optional)
      'SearchOption',
      'PrintOption',
      'DownloadOption'
    ]
  };

  addRedaction(): void {
    if (!this.pdfViewer) { return; }

    this.pdfViewer.annotation.addAnnotation('Redaction', {
      bound: { x: 200, y: 480, width: 150, height: 75 },
      pageNumber: 1,
      markerFillColor: '#0000FF',
      markerBorderColor: 'white',
      fillColor: 'red',
      overlayText: 'Confidential',
      fontColor: 'yellow',
      fontFamily: 'Times New Roman',
      fontSize: 8,
      beforeRedactionsApplied: false
    } as any);
  }

  //You can listen to the annotationAdd event to track when annotations are added.
  onAnnotationAdd(args: any): void {
    console.log('Annotation added:', args);
  }
}

Delete redaction annotations programmatically

Redaction annotations can be removed using the deleteAnnotationById method or by selecting and deleting them through code.

import { Component, ViewChild } from '@angular/core';
import {
  PdfViewerComponent,
  AnnotationService,
  ToolbarService,
  LinkAnnotationService,
  BookmarkViewService,
  MagnificationService,
  ThumbnailViewService,
  NavigationService,
  TextSearchService,
  TextSelectionService,
  PrintService,
  FormFieldsService,
  FormDesignerService,
  PageOrganizerService,
  ToolbarSettingsModel
} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  template: `
    <div style="margin-bottom:8px;">
      <button (click)="deleteAnnotationById()">Delete Annotation By Id</button>
    </div>
    <ejs-pdfviewer
      #pdfviewer
      id="PdfViewer"
      [documentPath]="document"
      [resourceUrl]="resource"
      [toolbarSettings]="toolbarSettings"
      style="height:640px;display:block">
    </ejs-pdfviewer>
  `,
  providers: [
    AnnotationService,
    ToolbarService,
    LinkAnnotationService,
    BookmarkViewService,
    MagnificationService,
    ThumbnailViewService,
    NavigationService,
    TextSearchService,
    TextSelectionService,
    PrintService,
    FormFieldsService,
    FormDesignerService,
    PageOrganizerService
  ]
})
export class AppComponent {
  @ViewChild('pdfviewer', { static: true }) pdfViewer!: PdfViewerComponent;

  public document = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';
  public resource = 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib';
  // Keep toolbar simple; include redaction edit tool if you want UI access too
  public toolbarSettings: ToolbarSettingsModel = {
    toolbarItems: [
      'OpenOption',
      'PageNavigationTool',
      'MagnificationTool',
      'PanTool',
      'SelectionTool',
      'AnnotationEditTool',
      'RedactionEditTool',   // shows the redaction UI tool (optional)
      'SearchOption',
      'PrintOption',
      'DownloadOption'
    ]
  };

  deleteAnnotationById(): void {
    this.pdfViewer.annotationModule.deleteAnnotationById(
      (this.pdfViewer as any).annotationCollection[0].annotationId
    );
  }
}

Alternatively, you can remove annotations by selecting them in the UI and pressing the Delete key.

Update redaction annotation properties programmatically

You can update properties of an existing redaction annotation using the editAnnotation API. For example, to change overlay text or fill color:

import { Component, ViewChild } from '@angular/core';
import {
  PdfViewerComponent,
  AnnotationService,
  ToolbarService,
  LinkAnnotationService,
  BookmarkViewService,
  MagnificationService,
  ThumbnailViewService,
  NavigationService,
  TextSearchService,
  TextSelectionService,
  PrintService,
  FormFieldsService,
  FormDesignerService,
  PageOrganizerService,
  ToolbarSettingsModel
} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  template: `
    <div style="margin-bottom:8px; display:flex; gap:8px;">
      <button id="editRedactAnnotation" (click)="editRedactAnnotation()">
        Edit Redact Annotation
      </button>
    </div>
    <ejs-pdfviewer
      #pdfviewer
      id="PdfViewer"
      [documentPath]="document"
      [resourceUrl]="resource"
      [toolbarSettings]="toolbarSettings"
      style="height:640px; display:block">
    </ejs-pdfviewer>
  `,
  providers: [
    AnnotationService,
    ToolbarService,
    LinkAnnotationService,
    BookmarkViewService,
    MagnificationService,
    ThumbnailViewService,
    NavigationService,
    TextSearchService,
    TextSelectionService,
    PrintService,
    FormFieldsService,
    FormDesignerService,
    PageOrganizerService
  ]
})
export class AppComponent {
  @ViewChild('pdfviewer', { static: true }) pdfViewer!: PdfViewerComponent;

  public document = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';
  public resource = 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib';

  public toolbarSettings: ToolbarSettingsModel = {
    toolbarItems: [
      'OpenOption',
      'PageNavigationTool',
      'MagnificationTool',
      'PanTool',
      'SelectionTool',
      'AnnotationEditTool',
      'RedactionEditTool',   // shows the redaction UI tool (optional)
      'SearchOption',
      'PrintOption',
      'DownloadOption'
    ]
  };

  //Edit RedactionAnnotation
  editRedactAnnotation(): void {
    const collection: any[] = (this.pdfViewer as any).annotationCollection;
    for (let i = 0; i < collection.length; i++) {
      if (collection[i].subject === 'Redaction') {
        collection[i].overlayText = 'EditedAnnotation';
        collection[i].markerFillColor = '#22FF00';
        collection[i].markerBorderColor = '#000000';
        collection[i].isRepeat = true;
        collection[i].fillColor = '#F8F8F8';
        collection[i].fontColor = '#333333';
        collection[i].fontSize = 14;
        collection[i].fontFamily = 'Symbol';
        collection[i].textAlign = 'Right';
        collection[i].beforeRedactionsApplied = false;

        (this.pdfViewer as any).annotation.editAnnotation(collection[i]);
      }
    }
  }
}

Add page redactions programmatically

Entire pages can be marked for redaction using the addPageRedactions method:

import { Component, ViewChild, AfterViewInit } from '@angular/core';
import {
  PdfViewerComponent,
  AnnotationService,
  ToolbarService,
  LinkAnnotationService,
  BookmarkViewService,
  MagnificationService,
  ThumbnailViewService,
  NavigationService,
  TextSearchService,
  TextSelectionService,
  PrintService,
  FormFieldsService,
  FormDesignerService,
  PageOrganizerService,
  ToolbarSettingsModel
} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  template: `
    <div style="margin-bottom:8px; display:flex; gap:8px; align-items:center;">
      <!-- Add page redactions programmatically -->
      <button id="addPageRedactions" type="button" (click)="addPageRedactions()">
        Add Page Redaction
      </button>
    </div>
    <ejs-pdfviewer
      #pdfviewer
      id="PdfViewer"
      [documentPath]="document"
      [resourceUrl]="resource"
      [toolbarSettings]="toolbarSettings"
      style="height:640px; display:block">
    </ejs-pdfviewer>
  `,
  providers: [
    AnnotationService,
    ToolbarService,
    LinkAnnotationService,
    BookmarkViewService,
    MagnificationService,
    ThumbnailViewService,
    NavigationService,
    TextSearchService,
    TextSelectionService,
    PrintService,
    FormFieldsService,
    FormDesignerService,
    PageOrganizerService
  ]
})
export class AppComponent implements AfterViewInit {
  @ViewChild('pdfviewer', { static: true }) pdfViewer!: PdfViewerComponent;

  public document = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';
  public resource = 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib';

  public toolbarSettings: ToolbarSettingsModel = {
    toolbarItems: [
      'OpenOption',
      'PageNavigationTool',
      'MagnificationTool',
      'PanTool',
      'SelectionTool',
      'AnnotationEditTool',
      'RedactionEditTool',   // shows the redaction UI tool (optional)
      'SearchOption',
      'PrintOption',
      'DownloadOption'
    ]
  };

  //Add page redactions programmatically (pages 1, 3, 5, 7)
  addPageRedactions(): void {
    this.pdfViewer.annotation.addPageRedactions([1, 3, 5, 7]);
  }
}

Apply redaction programmatically

Once annotations are added, you can permanently apply them to the document using the redact method:

import { Component, ViewChild, AfterViewInit } from '@angular/core';
import {
  PdfViewerComponent,
  AnnotationService,
  ToolbarService,
  LinkAnnotationService,
  BookmarkViewService,
  MagnificationService,
  ThumbnailViewService,
  NavigationService,
  TextSearchService,
  TextSelectionService,
  PrintService,
  FormFieldsService,
  FormDesignerService,
  PageOrganizerService,
  ToolbarSettingsModel
} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  template: `
    <div style="margin-bottom:8px; display:flex; gap:8px; align-items:center;">
      <button id="redact" type="button" (click)="applyRedaction()">
        Apply Redaction
      </button>
    </div>
    <ejs-pdfviewer
      #pdfviewer
      id="PdfViewer"
      [documentPath]="document"
      [resourceUrl]="resource"
      [toolbarSettings]="toolbarSettings"
      style="height:640px; display:block">
    </ejs-pdfviewer>
  `,
  providers: [
    AnnotationService,
    ToolbarService,
    LinkAnnotationService,
    BookmarkViewService,
    MagnificationService,
    ThumbnailViewService,
    NavigationService,
    TextSearchService,
    TextSelectionService,
    PrintService,
    FormFieldsService,
    FormDesignerService,
    PageOrganizerService
  ]
})
export class AppComponent implements AfterViewInit {
  @ViewChild('pdfviewer', { static: true }) pdfViewer!: PdfViewerComponent;

  public document = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';
  public resource = 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib';

  public toolbarSettings: ToolbarSettingsModel = {
    toolbarItems: [
      'OpenOption',
      'PageNavigationTool',
      'MagnificationTool',
      'PanTool',
      'SelectionTool',
      'AnnotationEditTool',
      'RedactionEditTool',   // shows the redaction UI tool (optional)
      'SearchOption',
      'PrintOption',
      'DownloadOption'
    ]
  };

  //Apply redaction programmatically (irreversible)
  applyRedaction(): void {
    this.pdfViewer.annotation.redact();
  }
}

NOTE

Applying redaction is irreversible. Before calling redact(), save or export a backup copy of the document; the original content cannot be recovered.

Configure default redaction annotation properties

You can configure default properties for redaction annotations (such as fill color, overlay text, and font) when adding them programmatically:

import { Component, ViewChild, AfterViewInit } from '@angular/core';
import {
  PdfViewerComponent,
  AnnotationService,
  ToolbarService,
  LinkAnnotationService,
  BookmarkViewService,
  MagnificationService,
  ThumbnailViewService,
  NavigationService,
  TextSearchService,
  TextSelectionService,
  PrintService,
  FormFieldsService,
  FormDesignerService,
  PageOrganizerService,
  ToolbarSettingsModel
} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  template: `
    <div style="margin-bottom:8px; display:flex; gap:8px; align-items:center;">
    </div>
    <ejs-pdfviewer
      #pdfviewer
      id="PdfViewer"
      [documentPath]="document"
      [resourceUrl]="resource"
      [toolbarSettings]="toolbarSettings"
      style="height:640px; display:block">
    </ejs-pdfviewer>
  `,
  providers: [
    AnnotationService,
    ToolbarService,
    LinkAnnotationService,
    BookmarkViewService,
    MagnificationService,
    ThumbnailViewService,
    NavigationService,
    TextSearchService,
    TextSelectionService,
    PrintService,
    FormFieldsService,
    FormDesignerService,
    PageOrganizerService
  ]
})
export class AppComponent implements AfterViewInit {
  @ViewChild('pdfviewer', { static: true }) pdfViewer!: PdfViewerComponent;

  public document = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';
  public resource = 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib';

  public toolbarSettings: ToolbarSettingsModel = {
    toolbarItems: [
      'OpenOption',
      'PageNavigationTool',
      'MagnificationTool',
      'PanTool',
      'SelectionTool',
      'AnnotationEditTool',
      'RedactionEditTool',   // shows the redaction UI tool (optional)
      'SearchOption',
      'PrintOption',
      'DownloadOption'
    ]
  };

  //Configure default redaction annotation properties (same as your JS)
  ngAfterViewInit(): void {
    (this.pdfViewer as any).redactionSettings = {
      overlayText: 'Confidential',
      markerFillColor: '#FF0000',
      markerBorderColor: '#000000',
      isRepeat: false,
      fillColor: '#F8F8F8',
      fontColor: '#333333',
      fontSize: 14,
      fontFamily: 'Symbol',
      textAlign: 'Right'
    };
  }
}

View sample repository on GitHub

Redaction property panel

The redaction property panel allows users to update annotation properties through the UI. Programmatically, you can invoke the property panel by selecting an annotation and calling the relevant APIs. Properties such as overlay text, font style, and fill color can be updated directly in the panel.

Redaction property panel showing overlay text and color options

See also

Programmatic support for redaction in Vue PdfViewer

28 Feb 202624 minutes to read

The Syncfusion Vue PdfViewer control provides APIs to add, update, delete, and apply redaction annotations programmatically. You can also redact entire pages, configure default properties, and work with the redaction property panel.

Enable the redaction toolbar

To enable the redaction toolbar, configure the toolbarSettings.toolbarItems property of the PdfViewer instance to include the RedactionEditTool.

The following example shows how to enable the redaction toolbar:

<template>
  <div>
    <div class="control-section">
      <ejs-pdfviewer
        id="container"
        :documentPath="documentPath"
        :resourceUrl="resourceUrl"
        :toolbarSettings="toolbarSettings"
        style="height: 680px"
      />
    </div>
  </div>
</template>
<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  LinkAnnotation,
  BookmarkView,
  ThumbnailView,
  Print,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  name: 'App',
  components: { 'ejs-pdfviewer': PdfViewerComponent },
  data() {
    return {
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib',
      documentPath: 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
      toolbarSettings: {
        toolbarItems: [
          'OpenOption',
          'UndoRedoTool',
          'PageNavigationTool',
          'MagnificationTool',
          'PanTool',
          'SelectionTool',
          'CommentTool',
          'SubmitForm',
          'AnnotationEditTool',
          'RedactionEditTool',
          'FormDesignerEditTool',
          'SearchOption',
          'PrintOption',
          'DownloadOption'
        ]
      }
    };
  },
  provide: {
    PdfViewer: [
      Toolbar,
      Magnification,
      Navigation,
      Annotation,
      LinkAnnotation,
      BookmarkView,
      ThumbnailView,
      Print,
      TextSelection,
      TextSearch,
      FormFields,
      FormDesigner,
      PageOrganizer
    ]
  }
};
</script>

Add redaction annotations programmatically

You can add redaction annotations to a PDF document using the addAnnotation method of the annotation module. You can listen to the annotationAdd event to track when annotations are added.

<template>
  <div class="content-wrapper">
    <div style="margin-bottom: 8px; display: flex; gap: 8px; align-items: center;">
      <button id="addRedactAnnot" type="button" @click="addRedaction">
        Add Redaction Annotation
      </button>
    </div>
    <ejs-pdfviewer
      ref="pdfviewer"
      id="container"
      :documentPath="documentPath"
      :resourceUrl="resourceUrl"
      :toolbarSettings="toolbarSettings"
      style="height: 640px; display: block;"
      :annotationAdd="onAnnotationAdd"
    />
  </div>
</template>

<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  LinkAnnotation,
  BookmarkView,
  ThumbnailView,
  Print,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  name: 'App',
  components: {
    'ejs-pdfviewer': PdfViewerComponent
  },
  data() {
    return {
      documentPath: 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib',
      toolbarSettings: {
        toolbarItems: [
          'OpenOption',
          'UndoRedoTool',
          'PageNavigationTool',
          'MagnificationTool',
          'PanTool',
          'SelectionTool',
          'CommentTool',
          'SubmitForm',
          'AnnotationEditTool',
          'RedactionEditTool',
          'FormDesignerEditTool',
          'SearchOption',
          'PrintOption',
          'DownloadOption'
        ]
      }
    };
  },
  provide: {
    PdfViewer: [
      Toolbar,
      Magnification,
      Navigation,
      Annotation,
      LinkAnnotation,
      BookmarkView,
      ThumbnailView,
      Print,
      TextSelection,
      TextSearch,
      FormFields,
      FormDesigner,
      PageOrganizer
    ]
  },
  methods: {
    addRedaction() {
      const inst = this.$refs.pdfviewer?.ej2Instances;
      if (!inst) return;
      inst.annotation.addAnnotation('Redaction', {
        bound: { x: 200, y: 480, width: 150, height: 75 },
        pageNumber: 1,
        markerFillColor: '#0000FF',
        markerBorderColor: 'white',
        fillColor: 'red',
        overlayText: 'Confidential',
        fontColor: 'yellow',
        fontFamily: 'Times New Roman',
        fontSize: 8,
        beforeRedactionsApplied: false
      });
    },
    onAnnotationAdd(args) {
      console.log('Annotation added:', args);
    }
  }
};
</script>

Delete redaction annotations programmatically

Redaction annotations can be removed using the deleteAnnotationById method or by selecting and deleting them through code.

<template>
  <div>
    <div style="margin-bottom: 8px;">
      <button @click="deleteAnnotationById">Delete Annotation By Id</button>
    </div>
    <ejs-pdfviewer
      ref="pdfviewer"
      id="container"
      :documentPath="documentPath"
      :resourceUrl="resourceUrl"
      :toolbarSettings="toolbarSettings"
      style="height: 640px; display: block;"
    />
  </div>
</template>
<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  LinkAnnotation,
  BookmarkView,
  ThumbnailView,
  Print,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  name: 'App',
  components: { 'ejs-pdfviewer': PdfViewerComponent },
  data() {
    return {
      documentPath: 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib',
      toolbarSettings: {
        toolbarItems: [
          'OpenOption',
          'UndoRedoTool',
          'PageNavigationTool',
          'MagnificationTool',
          'PanTool',
          'SelectionTool',
          'CommentTool',
          'SubmitForm',
          'AnnotationEditTool',
          'RedactionEditTool',
          'FormDesignerEditTool',
          'SearchOption',
          'PrintOption',
          'DownloadOption'
        ]
      }
    };
  },
  provide: {
    PdfViewer: [
      Toolbar,
      Magnification,
      Navigation,
      Annotation,
      LinkAnnotation,
      BookmarkView,
      ThumbnailView,
      Print,
      TextSelection,
      TextSearch,
      FormFields,
      FormDesigner,
      PageOrganizer
    ]
  },
  methods: {
    deleteAnnotationById() {
      const inst = this.$refs.pdfviewer?.ej2Instances;
      if (!inst) return;
      const id = inst.annotationCollection?.[0]?.annotationId;
      if (id) {
        inst.annotationModule.deleteAnnotationById(id);
      }
    }
  }
};
</script>

Alternatively, you can remove annotations by selecting them in the UI and pressing the Delete key.

Update redaction annotation properties programmatically

You can update properties of an existing redaction annotation using the editAnnotation API. For example, to change overlay text or fill color:

<template>
  <div>
    <div style="margin-bottom: 8px; display: flex; gap: 8px;">
      <button id="editRedactAnnotation" @click="editRedactAnnotation">
        Edit Redact Annotation
      </button>
    </div>
    <ejs-pdfviewer
      ref="pdfviewer"
      id="container"
      :documentPath="documentPath"
      :resourceUrl="resourceUrl"
      :toolbarSettings="toolbarSettings"
      style="height: 640px; display: block;"
    />
  </div>
</template>
<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  LinkAnnotation,
  BookmarkView,
  ThumbnailView,
  Print,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  name: 'App',
  components: { 'ejs-pdfviewer': PdfViewerComponent },
  data() {
    return {
      documentPath: 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib',
      toolbarSettings: {
        toolbarItems: [
          'OpenOption',
          'UndoRedoTool',
          'PageNavigationTool',
          'MagnificationTool',
          'PanTool',
          'SelectionTool',
          'CommentTool',
          'SubmitForm',
          'AnnotationEditTool',
          'RedactionEditTool',
          'FormDesignerEditTool',
          'SearchOption',
          'PrintOption',
          'DownloadOption'
        ]
      }
    };
  },
  provide: {
    PdfViewer: [
      Toolbar,
      Magnification,
      Navigation,
      Annotation,
      LinkAnnotation,
      BookmarkView,
      ThumbnailView,
      Print,
      TextSelection,
      TextSearch,
      FormFields,
      FormDesigner,
      PageOrganizer
    ]
  },
  methods: {
    editRedactAnnotation() {
      const inst = this.$refs.pdfviewer?.ej2Instances;
      if (!inst) return;
      const collection = inst.annotationCollection || [];
      for (let i = 0; i < collection.length; i++) {
        if (collection[i].subject === 'Redaction') {
          collection[i].overlayText = 'EditedAnnotation';
          collection[i].markerFillColor = '#22FF00';
          collection[i].markerBorderColor = '#000000';
          collection[i].isRepeat = true;
          collection[i].fillColor = '#F8F8F8';
          collection[i].fontColor = '#333333';
          collection[i].fontSize = 14;
          collection[i].fontFamily = 'Symbol';
          collection[i].textAlign = 'Right';
          collection[i].beforeRedactionsApplied = false;
          inst.annotation.editAnnotation(collection[i]);
        }
      }
    }
  }
};
</script>

Add page redactions programmatically

Entire pages can be marked for redaction using the addPageRedactions method:

<template>
  <div>
    <div style="margin-bottom: 8px; display: flex; gap: 8px; align-items: center;">
      <button id="addPageRedactions" type="button" @click="addPageRedactions">
        Add Page Redaction
      </button>
    </div>
    <ejs-pdfviewer
      ref="pdfviewer"
      id="container"
      :documentPath="documentPath"
      :resourceUrl="resourceUrl"
      :toolbarSettings="toolbarSettings"
      style="height: 640px; display: block;"
    />
  </div>
</template>
<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  LinkAnnotation,
  BookmarkView,
  ThumbnailView,
  Print,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  name: 'App',
  components: { 'ejs-pdfviewer': PdfViewerComponent },
  data() {
    return {
      documentPath: 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib',
      toolbarSettings: {
        toolbarItems: [
          'OpenOption',
          'UndoRedoTool',
          'PageNavigationTool',
          'MagnificationTool',
          'PanTool',
          'SelectionTool',
          'CommentTool',
          'SubmitForm',
          'AnnotationEditTool',
          'RedactionEditTool',
          'FormDesignerEditTool',
          'SearchOption',
          'PrintOption',
          'DownloadOption'
        ]
      }
    };
  },
  provide: {
    PdfViewer: [
      Toolbar,
      Magnification,
      Navigation,
      Annotation,
      LinkAnnotation,
      BookmarkView,
      ThumbnailView,
      Print,
      TextSelection,
      TextSearch,
      FormFields,
      FormDesigner,
      PageOrganizer
    ]
  },
  methods: {
    addPageRedactions() {
      const inst = this.$refs.pdfviewer?.ej2Instances;
      if (!inst) return;
      inst.annotation.addPageRedactions([1, 3, 5, 7]);
    }
  }
};
</script>

Apply redaction programmatically

Once annotations are added, you can permanently apply them to the document using the redact method:

<template>
  <div>
    <div style="margin-bottom: 8px; display: flex; gap: 8px; align-items: center;">
      <button id="redact" type="button" @click="applyRedaction">
        Apply Redaction
      </button>
    </div>
    <ejs-pdfviewer
      ref="pdfviewer"
      id="container"
      :documentPath="documentPath"
      :resourceUrl="resourceUrl"
      :toolbarSettings="toolbarSettings"
      style="height: 640px; display: block;"
    />
  </div>
</template>
<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  LinkAnnotation,
  BookmarkView,
  ThumbnailView,
  Print,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  name: 'App',
  components: { 'ejs-pdfviewer': PdfViewerComponent },
  data() {
    return {
      documentPath: 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib',
      toolbarSettings: {
        toolbarItems: [
          'OpenOption',
          'UndoRedoTool',
          'PageNavigationTool',
          'MagnificationTool',
          'PanTool',
          'SelectionTool',
          'CommentTool',
          'SubmitForm',
          'AnnotationEditTool',
          'RedactionEditTool',
          'FormDesignerEditTool',
          'SearchOption',
          'PrintOption',
          'DownloadOption'
        ]
      }
    };
  },
  provide: {
    PdfViewer: [
      Toolbar,
      Magnification,
      Navigation,
      Annotation,
      LinkAnnotation,
      BookmarkView,
      ThumbnailView,
      Print,
      TextSelection,
      TextSearch,
      FormFields,
      FormDesigner,
      PageOrganizer
    ]
  },
  methods: {
    applyRedaction() {
      const inst = this.$refs.pdfviewer?.ej2Instances;
      if (!inst) return;
      inst.annotation.redact();
    }
  }
};
</script>

NOTE

Applying redaction is irreversible. Before calling redact(), save or export a backup copy of the document; the original content cannot be recovered.

Configure default redaction annotation properties

You can configure default properties for redaction annotations (such as fill color, overlay text, and font) when adding them programmatically:

<template>
  <div>
    <ejs-pdfviewer
      ref="pdfviewer"
      id="container"
      :documentPath="documentPath"
      :resourceUrl="resourceUrl"
      :toolbarSettings="toolbarSettings"
      style="height: 640px; display: block;"
    />
  </div>
</template>
<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  LinkAnnotation,
  BookmarkView,
  ThumbnailView,
  Print,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  name: 'App',
  components: { 'ejs-pdfviewer': PdfViewerComponent },
  data() {
    return {
      documentPath: 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib',
      toolbarSettings: {
        toolbarItems: [
          'OpenOption',
          'UndoRedoTool',
          'PageNavigationTool',
          'MagnificationTool',
          'PanTool',
          'SelectionTool',
          'CommentTool',
          'SubmitForm',
          'AnnotationEditTool',
          'RedactionEditTool',
          'FormDesignerEditTool',
          'SearchOption',
          'PrintOption',
          'DownloadOption'
        ]
      }
    };
  },
  provide: {
    PdfViewer: [
      Toolbar,
      Magnification,
      Navigation,
      Annotation,
      LinkAnnotation,
      BookmarkView,
      ThumbnailView,
      Print,
      TextSelection,
      TextSearch,
      FormFields,
      FormDesigner,
      PageOrganizer
    ]
  },
  mounted() {
    const inst = this.$refs.pdfviewer?.ej2Instances;
    if (!inst) return;
    inst.redactionSettings = {
      overlayText: 'Confidential',
      markerFillColor: '#FF0000',
      markerBorderColor: '#000000',
      isRepeat: false,
      fillColor: '#F8F8F8',
      fontColor: '#333333',
      fontSize: 14,
      fontFamily: 'Symbol',
      textAlign: 'Right'
    };
  }
};
</script>

View Sample in GitHub

Redaction property panel

The redaction property panel allows users to update annotation properties through the UI. Programmatically, you can invoke the property panel by selecting an annotation and calling the relevant APIs. Properties such as overlay text, font style, and fill color can be updated directly in the panel.

Redaction property panel showing overlay text and color options

See also